/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCategoria;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaCategoriaController")
@Scope("prototype")
public class BusquedaCategoriaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<Categoria> plwCategoria;
	private MyListbox categoriaList;
	private Paging pagingCategoria;
	private Textbox txtNombre;

	public Paging getPagingCategoria() {
		return pagingCategoria;
	}

	public void setPagingCategoria(Paging pagingCategoria) {
		this.pagingCategoria = pagingCategoria;
	}

	public MyListbox getCategoriaList() {
		return categoriaList;
	}

	public void setCategoriaList(MyListbox categoriaList) {
		this.categoriaList = categoriaList;
	}

	public PagedListWrapper<Categoria> getPlwCategoria() {
		return plwCategoria;
	}

	public void setPlwCategoria(PagedListWrapper<Categoria> plwCategoria) {
		this.plwCategoria = plwCategoria;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new Categoria());
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		categoriaList.setItemRenderer(new RenderCategoria());
		categoriaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Categoria c = (Categoria) categoriaList.getSelected();
				verPeriodo(c);
			}
		});

		refreshLista();

		txtNombre.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verPeriodo(Categoria c) {
		if (c == null) {
			return;
		}

		Map args = new HashMap();
		args.put("categoria", c);
		args.put("categoriaList", categoriaList);

		openWindow("/gui/catalogos/editarCategoria.zul",
				Labels.getLabel("editarCategoriaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<Categoria> claseServicioBusqueda =
				new HibernateSearchObject<Categoria>(Categoria.class, pagingCategoria.getPageSize());

		claseServicioBusqueda.addFilterLike("desccategoria", "%" + txtNombre.getText().trim().concat("%"));
		claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
		claseServicioBusqueda.addFilterNotEqual("categoriaId", -1);
		claseServicioBusqueda.addSortAsc("desccategoria");

		plwCategoria.init(claseServicioBusqueda, categoriaList, pagingCategoria);
		if (categoriaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaCategoriaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
}
